@echo off
echo OFF
REM IBM WebSphere Application Server V4.0.1 Advanced Edition Single Server Fixpack
set COPYCMD=/Y
Set PTFNUM=ptf_2
set SILENT=false
Set OverWriteBUJ=

IF    (%1) == ()         goto check_was_off
IF /I (%1) == (-silent)  goto set_silent_true

REM Any other flags are incorrect.
:silent_usage
echo.
echo Usage:To run the silent ptf install, please type: install.bat -silent
echo.
echo       Also, please have these variables set in the shell:
echo       WAS_HOME : Set this to the WebSphere root directory.
echo                 (eg: c:\WebSphere\AppServer)
echo.
echo       IHS_INSTALL : Set this to "true" or "false" regarding
echo                upgrading the IBM HTTP Server.
echo.
echo       IHS_HOME : Set this to the IBM HTTP Server root directory if
echo                upgrading IHS.
echo                 (eg: c:\Program Files\IBM HTTP Server)
echo.
goto exit

:set_silent_true
set SILENT=true
goto check_silent_vars

:check_was_off
echo.
echo    WebSphere Application Server 4.0, Advanced Edition, Single Server PTF 2
echo.
echo Please shut down the Application Server and any Webservers that might be
echo running.  If not the PTF may not be installed properly.
echo.
GetInput F_RES "Please press return to continue. " ~wasshut.bat
call ~wasshut.bat
del ~wasshut.bat
set WAS_HOME=

:check_was_home
if (%WAS_HOME%) == () goto prompt_was_home
set F_WAS_HOME=%WAS_HOME%
goto verify_was_home

:prompt_was_home
if (%SILENT%)==(true)  goto silent_usage
REM Get WAS Install Dir
GetInput F_WAS_HOME "Enter the directory where the IBM WebSphere Application Server is installed: " ~washome.bat
call ~washome.bat
del ~washome.bat

:verify_was_home
@Rem IF NOT EXIST %F_WAS_HOME%\properties\com\ibm\websphere\product.xml   goto bad_was_home

IF NOT EXIST %F_WAS_HOME%\java\jre\bin\java.exe goto setup_jre
set F_JDK_HOME=%F_WAS_HOME%\java
goto echo_vars:
:setup_jre
set F_JDK_HOME=%F_WAS_HOME%\jre

:echo_vars
echo WASHOME %F_WAS_HOME%
echo JDKHOME %F_JDK_HOME%

copy GetInput.exe %F_WAS_HOME%

:check_java_home
if exist %F_JDK_HOME%\jre\bin\java.exe  goto run_fixpack

:prompt_java_home
GetInput F_JDK_HOME "Enter the directory where the IBM JDK or JRE is installed: " ~jdkhome.bat
call ~jdkhome.bat
del ~jdkhome.bat
goto check_java_home

:run_fixpack
echo "Installing the WebSphere Application Server Advanced Edition Single Server Version 4.0 PTF 2"
%F_JDK_HOME%\jre\bin\java -jar was40_aes_%PTFNUM%.jar -target %F_WAS_HOME% -backupJar %F_WAS_HOME%\was40_aes_%PTFNUM%_backup.jar -log %F_WAS_HOME%/logs/was40_aes_%PTFNUM%.log %OverWriteBUJ%
if (%errorlevel%) NEQ (0) goto was_ptf_error


:upgrade_jdk
echo Upgrading IBM JDK
xcopy %F_JDK_HOME%\* %F_WAS_HOME%\java_%PTFNUM% /e/q/i
%F_JDK_HOME%\jre\bin\java -jar jdk_%PTFNUM%.jar -target %F_WAS_HOME%\java_%PTFNUM% -backupJar %F_WAS_HOME%\jdk_%PTFNUM%_backup.jar -log %F_WAS_HOME%/logs/jdk_%PTFNUM%.log -SkipVer %OverWriteBUJ%
if (%errorlevel%) NEQ (0) goto jdk_ptf_error
if (%SILENT%) == (true) goto no_pause
pause
:no_pause
xcopy %F_WAS_HOME%\java_%PTFNUM%\* %F_JDK_HOME% /e/q/i
rmdir %F_WAS_HOME%\java_%PTFNUM% /S/Q


:prompt_ihs
if (%SILENT%) == (true) goto verify_ihs
REM Install IHS?
echo WARNING: If you install IBM HTTP Server PTF, you may not be able to uninstall it cleanly. The GSkit package will not be uninstalled.
GetInput F_IHS_YN "Do you wish to upgrade the IBM HTTP Server:(Yes/No) " ~ihsprompt.bat
call ~ihsprompt.bat
del ~ihsprompt.bat
if (%F_IHS_YN%) == (yes) goto check_for_ihs
if (%F_IHS_YN%) == (Yes) goto check_for_ihs
if (%F_IHS_YN%) == (YES) goto check_for_ihs
if (%F_IHS_YN%) == (y) goto check_for_ihs
if (%F_IHS_YN%) == (Y) goto check_for_ihs
goto complete

:check_for_ihs
REM Enter IHS home path
GetInput F_IHS_HOME "Enter the directory where the IBM HTTP Server is installed: " ~ihshome.bat
call ~ihshome.bat
del ~ihshome.bat
if "%F_IHS_HOME%" == "" goto complete

:verify_ihs
REM CHeck silent install variable IHS_INSTALL first.  If equal blank, regular install continues.
if (%IHS_INSTALL%) == (false) goto complete
if (%IHS_INSTALL%) == (true)  set F_IHS_HOME=%IHS_HOME%
if (%IHS_INSTALL%) == (true)  goto upgrade_ihs
if exist "%F_IHS_HOME%\conf\httpd.conf" goto upgrade_ihs
echo Unable to find IBM HTTP Server Application in specified path: %F_IHS_HOME%
goto prompt_ihs

:upgrade_ihs
echo Upgrading IHS
%F_JDK_HOME%\jre\bin\java -jar ihs_%PTFNUM%.jar -target "%F_IHS_HOME%" -backupJar %F_WAS_HOME%\ihs_%PTFNUM%_backup.jar -log %F_WAS_HOME%/logs/ihs_%PTFNUM%.log -SkipVer %OverWriteBUJ%
if (%errorlevel%) NEQ (0) goto ihs_ptf_error
REM install GSKIT
"%F_IHS_HOME%\skit\setup" GSkit5 "%SystemDrive%\Program Files" -s -f2.\gskit5.log
if (%errorlevel%) NEQ (0) goto ihs_ptf_error

goto complete

:bad_was_home
echo Error -- Can not find WebSphere Application Server in %F_WAS_HOME%
echo Install aborted
goto exit


:check_silent_vars
Set OverWriteBUJ=-OverWriteBackupJar
IF NOT EXIST "%WAS_HOME%\properties\com\ibm\websphere\product.xml" echo Invalid WAS_HOME set.
IF NOT EXIST "%WAS_HOME%\properties\com\ibm\websphere\product.xml" goto silent_usage

IF (%IHS_INSTALL%) == () echo IHS_INSTALL is not set to true or false.
IF (%IHS_INSTALL%) == () goto silent_usage

IF (%IHS_INSTALL%) NEQ (false) goto ihs_silent_true
goto check_was_home


:ihs_silent_true
IF (%IHS_INSTALL%) NEQ (true) echo IHS_INSTALL is not set correctly to true or false.
IF (%IHS_INSTALL%) NEQ (true) goto silent_usage

IF NOT EXIST "%IHS_HOME%\conf\httpd.conf"  echo IHS_INSTALL=true and IHS_HOME is not set correctly.
IF NOT EXIST "%IHS_HOME%\conf\httpd.conf"  goto silent_usage
goto check_was_home


:was_ptf_error
echo Either the user has chosen to exit, or there was an error during the WebSphere PTF upgrade.
echo In case of error, run uninstall_%PTFNUM%.bat to back out the changes.
echo The PTF upgrade will end now.
goto exit

:jdk_ptf_error
echo Either the user has chosen to exit, or there was an error during the JDK PTF upgrade.
echo In case of error, run uninstall_%PTFNUM%.bat to back out the changes.
echo The PTF upgrade will end now.
goto exit

:ihs_ptf_error
echo Either the user has chosen to exit, or there was an error during the IBM HTTP Server PTF upgrade.
echo In case of error, run uninstall_%PTFNUM%.bat to back out the changes.
echo The PTF upgrade will end now.
goto exit

:complete
echo IBM WebSphere Application Server V4.0.2 AEs Fixpack install complete

:exit
@Rem    A pause is required when the install is launched through explorer
@Rem   When launched from the explorer
if (%SILENT%) == (true)        Goto Egress
if /I (%0)    == (install)     Goto Egress
if /I (%0)    == (install.bat) Goto Egress
Pause

:Egress
